#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#include "vector.h"
#include "obj.h"

int add_his( struct SelHist *his, int id ) ;
int del_his( struct SelHist *his, int id ) ;
int clr_his( struct SelHist *his ) ;

struct element_HG select_HG( struct View3D *view3d, struct HG_List *HGL, int mode )
{
  struct element_HG element=view3d->HGno ;

  if( element.n>=0 ){
    if(       (mode & 1)!=0 ){
      if( HGL->HG[element.n].sel==0 ){
	add_his( &view3d->his, element.n ) ;
      }
      HGL->HG[element.n].sel=1 ;
    }else if( (mode & 2)!=0 ){
      if( HGL->HG[element.n].sel==1 ){
	del_his( &view3d->his, element.n ) ;
      }
      HGL->HG[element.n].sel=0 ;
    }
  }

  view3d->HGno=element ;
  return(element) ;
}
  
int selectall_HG( struct View3D *view3d, struct HG_List *HGL, int mode )
{
  int i ;

  for( i=0 ; i<HGL->n ; i++ ){
    if(       (mode & 1)!=0 ){
      HGL->HG[i].sel=1 ;
    }else if( (mode & 2)!=0 ){
      HGL->HG[i].sel=0 ;
      clr_his( &view3d->his ) ;
    }
  }
  
  return(0) ;
}


int selectgid_HG( struct View3D *view3d, struct HG_List *HGL, int gid )
{
  int i ;

  for( i=0 ; i<HGL->n ; i++ ){
    if( HGL->HG[i].gid==gid ){
      HGL->HG[i].sel=1 ;
    }
  }
  
  return(0) ;
}
