/**************************************/
/* F^                               */
/**************************************/
typedef float objRGBA[4] ;

/**************************************/
/* (Op`|S)\           */
/**************************************/
struct Face3D{
  int p0,p1,p2        ; /** _XgID **/
  int dummy           ;
  struct Vec3D normal ; /** ʖ@       **/
  objRGBA ambient     ; /**  F    **/
  objRGBA diffuse     ; /** ̂̐F     **/
  objRGBA specular    ; /** nCCgF **/
  float   shininess   ;
} ;


/**************************************/
/* O[vp[^\           */
/**************************************/
struct GroupParams{
  objRGBA   lc     ; /** `J[   **/
  objRGBA   pc     ; /** _`J[ **/
  int       hide   ; /** \ON/OFF     **/
} ;
#define GPNUM (4)


/**************************************/
/* ZNgqXg\             */
/**************************************/
#define HISNUM  (32)
struct SelHist{
  int  buf[HISNUM] ;
  int  cur ;
  int  n ;
  int  num ;
} ;


/**************************************/
/* T[tFX\                   */
/**************************************/
#define HS_NUM  (128)
struct HairSurface{
  int hg1[HS_NUM] ;
  int hg2[HS_NUM] ;
  int n ;
  int num ;
} ;


/**************************************/
/* KCh\                       */
/**************************************/
struct HairGuide{
  int       type      ; /** `^Cv **/
  int       pnum      ; /** _   **/
  GLfloat   plist[24] ; /** OpenGL `p_Xg **/
  int       nknot     ; /** OpenGL `pKnot     **/
  GLfloat   knots[8]  ; /** OpenGL `pKnotXg **/
  int       gid       ; /** O[vID **/
  int       sel       ; /** ItO **/
  int       pid       ; /** э_ID **/
  struct Vec3D  rp    ; /** э_W(work) **/
  struct Vec3D  rn    ; /** э_@(work) **/
} ;

struct HG_List{
  struct HairGuide *HG ;
  int    n   ;
  int    max ;
} ;

struct element_HG{
  int   n ;         /** HairGuide io[ **/
  int   p ;         /** _io[     **/
} ;


/**************************************/
/* r[\                       */
/**************************************/
struct View3D{
  double         fov     ; /** p               **/
  struct Vec3D   v       ; /** Jʒu           **/
  struct Vec3D   c       ; /** ړ_               **/
  struct Vec3D   u       ; /** VxNg         **/
  struct Vec3D   r       ; /** ]px             **/
  struct Vec3D   p       ; /** pxNg         **/
  struct Vec3D   cur     ; /** OJ[\ʒu   **/
  struct Vec3D   sta     ; /** OJ[\[N **/
  int            win_w   ; /** ECh           **/
  int            win_h   ; /** ECh         **/
  int            id      ; /** JgKChID     **/
  double         scale   ; /** _ړʕ␳       **/
  struct GroupParams gp[GPNUM] ; /** O[vp[^ **/
  struct SelHist his      ; /** ZNgqXg    **/
  struct HairSurface hs   ; /** wAT[tFX      **/
  struct  element_HG HGno ; /** wAKChNo        **/
  int            HRno     ; /** wA[gNo        **/
} ;
  

/**************************************/
/* IuWFNg\                 */
/**************************************/
struct PolyObjData{
  double drawx,drawy,drawz ; /** `ʒu       **/
  double px,py,pz          ; /** ʒu           **/
  double ox,oy,oz          ; /** ]p         **/
  int            pnum      ; /** _         **/
  struct Vec3D  *plist     ; /** _Xg     **/
  struct Vec3D  *nlist     ; /** _@Xg **/
  int           *sel       ; /** _ItO **/
  int           *HGid      ; /** wAKChID(Ɨp) **/
  int           *draw      ; /** _\[N **/
  int            fnum      ; /** ʐ           **/
  struct Face3D *flist     ; /** ʃXg       **/
} ;

